// Created on 27.11.2004 by RST.
// $Id:$

package mandel;
import java.awt.BorderLayout;
import java.awt.Graphics;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.swing.JFrame;
import javax.swing.JPanel;

public class MandelGridMain extends JFrame
{

	private MandelCanvas canvas = new MandelCanvas();
	private GridManager gridmanager = new GridManager();

	private int width = 500;
	private int height = 400;


	private class MandelCanvas extends JPanel
	{
		//draws the grid.
		public void paint(Graphics g)
		{
			System.out.println("start paint");
			gridmanager.drawTo(g, height - 1);
			System.out.println("end paint");
		}
	}

	/** This is just for logging purposes. */
	private static SimpleDateFormat dateformat = new SimpleDateFormat("yyyy-MM-dd.HH.mm.ss.SSS");

	/** Returns the actual date in millisecond semi ISO format. */
	private static String date()
	{
		return dateformat.format(new Date());
	}

	/** This is the programm smain function. */
	public static void main(String args[]) throws Exception
	{
		new MandelGridMain().run(args);
	}

	/** Runs the Mandelbrot generator in fullscreen mode. */
	public void run(String args[]) throws Exception
	{
		
		PresetManager presets = new PresetManager();
		presets.init();
		gridmanager.init(width, height, presets.findPreset("ast_left"));
		System.out.println("Hello,world");
		System.out.println("It's now:" + date());
		JFrame frame = new MandelGridMain();
		frame.setSize(width, height);
		frame.setTitle("Mandelcalculator V0.1");
		frame.setUndecorated(true);

		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.getContentPane().setLayout(new BorderLayout());
		frame.getContentPane().add(canvas, BorderLayout.CENTER);
		frame.show();
		frame.addKeyListener(mandelKeyHandler);
	}

	/** This handles all the key events. */
	private KeyAdapter mandelKeyHandler = new KeyAdapter()
	{
		public void keyPressed(KeyEvent e)
		{
			System.out.println("" + e.getKeyCode());
			
			int code = e.getKeyCode();
			switch (code)
			{
				case 37 :
					gridmanager.moveview(-2, 0);
					break;
				case 38 :
					gridmanager.moveview(0, 2);
					break;

				case 39 :
					gridmanager.moveview(2, 0);
					break;

				case 40 :
					gridmanager.moveview(0, -2);
					break;
			}
			canvas.repaint();
		}
	};
}