/* RainbowPalette.java

   Mandelbrot Madness JAVA! 1.0

   PROGRAMMER:    Jeffrey T. Darlington
   DATE:          August 3, 1998
   PROJECT:       Mandelbrot Madness JAVA!
   JAVA VERSION:  1.0.2
   REQUIRES:      (None)
   REQUIRED BY:   MandelCanvas.java

   This class is nothing but a wrapper around the getColor()
   function, which simply returns the color from the 256-color
   Rainbow palette originally from the Win32 version of Mandelbrot
   Madness!  You can create new palettes by modifying the values
   below, saving this file under a different name (like 
   MyPalette.java) and the incorporating it into the Mandelbrot
   Madness JAVA! code.  To do the last part, simply replace

      RainbowPalette rb;

   in the declarations with

      MyPalette rb;
*/

package mandel;
import java.awt.Color;

public class RainbowPalette
{

	// The constructor is just a token function; it doesn't
	// really do anything.
	public RainbowPalette()
	{
	} // RainbowPalette constructor

	// getColor() returns the actual color (using the Rainbow
	// palette) of the index value (generated by the algorithm).
	public static Color getColor(int index)
	{
		Color c;
		switch (index)
		{
			case 0 :
				c= new Color(0, 0, 0);
				break;
			case 1 :
				c= new Color(0, 0, 160);
				break;
			case 2 :
				c= new Color(3, 0, 160);
				break;
			case 3 :
				c= new Color(6, 0, 159);
				break;
			case 4 :
				c= new Color(8, 0, 158);
				break;
			case 5 :
				c= new Color(11, 0, 158);
				break;
			case 6 :
				c= new Color(14, 0, 157);
				break;
			case 7 :
				c= new Color(16, 0, 156);
				break;
			case 8 :
				c= new Color(19, 0, 156);
				break;
			case 9 :
				c= new Color(21, 0, 155);
				break;
			case 10 :
				c= new Color(24, 0, 154);
				break;
			case 11 :
				c= new Color(27, 0, 154);
				break;
			case 12 :
				c= new Color(29, 0, 153);
				break;
			case 13 :
				c= new Color(32, 0, 153);
				break;
			case 14 :
				c= new Color(34, 0, 152);
				break;
			case 15 :
				c= new Color(37, 0, 151);
				break;
			case 16 :
				c= new Color(40, 0, 151);
				break;
			case 17 :
				c= new Color(42, 0, 150);
				break;
			case 18 :
				c= new Color(45, 0, 149);
				break;
			case 19 :
				c= new Color(48, 0, 149);
				break;
			case 20 :
				c= new Color(50, 0, 148);
				break;
			case 21 :
				c= new Color(53, 0, 147);
				break;
			case 22 :
				c= new Color(55, 0, 147);
				break;
			case 23 :
				c= new Color(58, 0, 146);
				break;
			case 24 :
				c= new Color(61, 0, 145);
				break;
			case 25 :
				c= new Color(63, 0, 145);
				break;
			case 26 :
				c= new Color(66, 0, 144);
				break;
			case 27 :
				c= new Color(68, 0, 143);
				break;
			case 28 :
				c= new Color(71, 0, 143);
				break;
			case 29 :
				c= new Color(74, 0, 142);
				break;
			case 30 :
				c= new Color(76, 0, 141);
				break;
			case 31 :
				c= new Color(79, 0, 141);
				break;
			case 32 :
				c= new Color(81, 0, 140);
				break;
			case 33 :
				c= new Color(84, 0, 139);
				break;
			case 34 :
				c= new Color(87, 0, 139);
				break;
			case 35 :
				c= new Color(89, 0, 138);
				break;
			case 36 :
				c= new Color(92, 0, 138);
				break;
			case 37 :
				c= new Color(95, 0, 137);
				break;
			case 38 :
				c= new Color(97, 0, 136);
				break;
			case 39 :
				c= new Color(100, 0, 136);
				break;
			case 40 :
				c= new Color(102, 0, 135);
				break;
			case 41 :
				c= new Color(105, 0, 134);
				break;
			case 42 :
				c= new Color(108, 0, 134);
				break;
			case 43 :
				c= new Color(110, 0, 133);
				break;
			case 44 :
				c= new Color(113, 0, 132);
				break;
			case 45 :
				c= new Color(115, 0, 132);
				break;
			case 46 :
				c= new Color(116, 0, 131);
				break;
			case 47 :
				c= new Color(121, 0, 130);
				break;
			case 48 :
				c= new Color(123, 0, 130);
				break;
			case 49 :
				c= new Color(126, 0, 129);
				break;
			case 50 :
				c= new Color(128, 0, 128);
				break;
			case 51 :
				c= new Color(128, 0, 128);
				break;
			case 52 :
				c= new Color(131, 0, 129);
				break;
			case 53 :
				c= new Color(133, 0, 123);
				break;
			case 54 :
				c= new Color(136, 0, 121);
				break;
			case 55 :
				c= new Color(138, 0, 118);
				break;
			case 56 :
				c= new Color(141, 0, 115);
				break;
			case 57 :
				c= new Color(144, 0, 113);
				break;
			case 58 :
				c= new Color(146, 0, 110);
				break;
			case 59 :
				c= new Color(149, 0, 108);
				break;
			case 60 :
				c= new Color(152, 0, 105);
				break;
			case 61 :
				c= new Color(154, 0, 102);
				break;
			case 62 :
				c= new Color(157, 0, 100);
				break;
			case 63 :
				c= new Color(159, 0, 97);
				break;
			case 64 :
				c= new Color(162, 0, 95);
				break;
			case 65 :
				c= new Color(165, 0, 92);
				break;
			case 66 :
				c= new Color(167, 0, 89);
				break;
			case 67 :
				c= new Color(170, 0, 87);
				break;
			case 68 :
				c= new Color(172, 0, 84);
				break;
			case 69 :
				c= new Color(175, 0, 81);
				break;
			case 70 :
				c= new Color(178, 0, 79);
				break;
			case 71 :
				c= new Color(180, 0, 76);
				break;
			case 72 :
				c= new Color(183, 0, 74);
				break;
			case 73 :
				c= new Color(185, 0, 71);
				break;
			case 74 :
				c= new Color(188, 0, 68);
				break;
			case 75 :
				c= new Color(191, 0, 66);
				break;
			case 76 :
				c= new Color(193, 0, 63);
				break;
			case 77 :
				c= new Color(195, 0, 61);
				break;
			case 78 :
				c= new Color(198, 0, 58);
				break;
			case 79 :
				c= new Color(201, 0, 55);
				break;
			case 80 :
				c= new Color(203, 0, 53);
				break;
			case 81 :
				c= new Color(205, 0, 50);
				break;
			case 82 :
				c= new Color(208, 0, 48);
				break;
			case 83 :
				c= new Color(211, 0, 45);
				break;
			case 84 :
				c= new Color(214, 0, 42);
				break;
			case 85 :
				c= new Color(216, 0, 40);
				break;
			case 86 :
				c= new Color(219, 0, 37);
				break;
			case 87 :
				c= new Color(222, 0, 34);
				break;
			case 88 :
				c= new Color(224, 0, 32);
				break;
			case 89 :
				c= new Color(227, 0, 29);
				break;
			case 90 :
				c= new Color(229, 0, 27);
				break;
			case 91 :
				c= new Color(232, 0, 24);
				break;
			case 92 :
				c= new Color(235, 0, 21);
				break;
			case 93 :
				c= new Color(237, 0, 19);
				break;
			case 94 :
				c= new Color(240, 0, 16);
				break;
			case 95 :
				c= new Color(242, 0, 14);
				break;
			case 96 :
				c= new Color(245, 0, 11);
				break;
			case 97 :
				c= new Color(248, 0, 8);
				break;
			case 98 :
				c= new Color(250, 0, 6);
				break;
			case 99 :
				c= new Color(253, 0, 3);
				break;
			case 100 :
				c= new Color(255, 0, 0);
				break;
			case 101 :
				c= new Color(255, 0, 0);
				break;
			case 102 :
				c= new Color(255, 0, 0);
				break;
			case 103 :
				c= new Color(255, 3, 0);
				break;
			case 104 :
				c= new Color(255, 5, 0);
				break;
			case 105 :
				c= new Color(255, 8, 0);
				break;
			case 106 :
				c= new Color(255, 10, 0);
				break;
			case 107 :
				c= new Color(255, 13, 0);
				break;
			case 108 :
				c= new Color(255, 16, 0);
				break;
			case 109 :
				c= new Color(255, 18, 0);
				break;
			case 110 :
				c= new Color(255, 21, 0);
				break;
			case 111 :
				c= new Color(255, 24, 0);
				break;
			case 112 :
				c= new Color(255, 26, 0);
				break;
			case 113 :
				c= new Color(255, 29, 0);
				break;
			case 114 :
				c= new Color(255, 31, 0);
				break;
			case 115 :
				c= new Color(255, 34, 0);
				break;
			case 116 :
				c= new Color(255, 37, 0);
				break;
			case 117 :
				c= new Color(255, 39, 0);
				break;
			case 118 :
				c= new Color(255, 42, 0);
				break;
			case 119 :
				c= new Color(255, 44, 0);
				break;
			case 120 :
				c= new Color(255, 47, 0);
				break;
			case 121 :
				c= new Color(255, 50, 0);
				break;
			case 122 :
				c= new Color(255, 52, 0);
				break;
			case 123 :
				c= new Color(255, 55, 0);
				break;
			case 124 :
				c= new Color(255, 57, 0);
				break;
			case 125 :
				c= new Color(255, 60, 0);
				break;
			case 126 :
				c= new Color(255, 63, 0);
				break;
			case 127 :
				c= new Color(255, 65, 0);
				break;
			case 128 :
				c= new Color(255, 68, 0);
				break;
			case 129 :
				c= new Color(255, 71, 0);
				break;
			case 130 :
				c= new Color(255, 73, 0);
				break;
			case 131 :
				c= new Color(255, 76, 0);
				break;
			case 132 :
				c= new Color(255, 78, 0);
				break;
			case 133 :
				c= new Color(255, 81, 0);
				break;
			case 134 :
				c= new Color(255, 84, 0);
				break;
			case 135 :
				c= new Color(255, 86, 0);
				break;
			case 136 :
				c= new Color(255, 89, 0);
				break;
			case 137 :
				c= new Color(255, 91, 0);
				break;
			case 138 :
				c= new Color(255, 94, 0);
				break;
			case 139 :
				c= new Color(255, 97, 0);
				break;
			case 140 :
				c= new Color(255, 99, 0);
				break;
			case 141 :
				c= new Color(255, 102, 0);
				break;
			case 142 :
				c= new Color(255, 104, 0);
				break;
			case 143 :
				c= new Color(255, 107, 0);
				break;
			case 144 :
				c= new Color(255, 110, 0);
				break;
			case 145 :
				c= new Color(255, 112, 0);
				break;
			case 146 :
				c= new Color(255, 115, 0);
				break;
			case 147 :
				c= new Color(255, 118, 0);
				break;
			case 148 :
				c= new Color(255, 120, 0);
				break;
			case 149 :
				c= new Color(255, 123, 0);
				break;
			case 150 :
				c= new Color(255, 125, 0);
				break;
			case 151 :
				c= new Color(255, 128, 0);
				break;
			case 152 :
				c= new Color(255, 128, 0);
				break;
			case 153 :
				c= new Color(255, 128, 0);
				break;
			case 154 :
				c= new Color(255, 134, 0);
				break;
			case 155 :
				c= new Color(255, 136, 0);
				break;
			case 156 :
				c= new Color(255, 139, 0);
				break;
			case 157 :
				c= new Color(255, 141, 0);
				break;
			case 158 :
				c= new Color(255, 144, 0);
				break;
			case 159 :
				c= new Color(255, 146, 0);
				break;
			case 160 :
				c= new Color(255, 149, 0);
				break;
			case 161 :
				c= new Color(255, 151, 0);
				break;
			case 162 :
				c= new Color(255, 154, 0);
				break;
			case 163 :
				c= new Color(255, 156, 0);
				break;
			case 164 :
				c= new Color(255, 159, 0);
				break;
			case 165 :
				c= new Color(255, 161, 0);
				break;
			case 166 :
				c= new Color(255, 164, 0);
				break;
			case 167 :
				c= new Color(255, 166, 0);
				break;
			case 168 :
				c= new Color(255, 169, 0);
				break;
			case 169 :
				c= new Color(255, 171, 0);
				break;
			case 170 :
				c= new Color(255, 174, 0);
				break;
			case 171 :
				c= new Color(255, 176, 0);
				break;
			case 172 :
				c= new Color(255, 179, 0);
				break;
			case 173 :
				c= new Color(255, 181, 0);
				break;
			case 174 :
				c= new Color(255, 184, 0);
				break;
			case 175 :
				c= new Color(255, 186, 0);
				break;
			case 176 :
				c= new Color(255, 189, 0);
				break;
			case 177 :
				c= new Color(255, 191, 0);
				break;
			case 178 :
				c= new Color(255, 193, 0);
				break;
			case 179 :
				c= new Color(255, 196, 0);
				break;
			case 180 :
				c= new Color(255, 198, 0);
				break;
			case 181 :
				c= new Color(255, 201, 0);
				break;
			case 182 :
				c= new Color(255, 203, 0);
				break;
			case 183 :
				c= new Color(255, 206, 0);
				break;
			case 184 :
				c= new Color(255, 208, 0);
				break;
			case 185 :
				c= new Color(255, 211, 0);
				break;
			case 186 :
				c= new Color(255, 213, 0);
				break;
			case 187 :
				c= new Color(255, 216, 0);
				break;
			case 188 :
				c= new Color(255, 218, 0);
				break;
			case 189 :
				c= new Color(255, 221, 0);
				break;
			case 190 :
				c= new Color(255, 223, 0);
				break;
			case 191 :
				c= new Color(255, 226, 0);
				break;
			case 192 :
				c= new Color(255, 228, 0);
				break;
			case 193 :
				c= new Color(255, 231, 0);
				break;
			case 194 :
				c= new Color(255, 233, 0);
				break;
			case 195 :
				c= new Color(255, 236, 0);
				break;
			case 196 :
				c= new Color(255, 238, 0);
				break;
			case 197 :
				c= new Color(255, 241, 0);
				break;
			case 198 :
				c= new Color(255, 243, 0);
				break;
			case 199 :
				c= new Color(255, 246, 0);
				break;
			case 200 :
				c= new Color(255, 248, 0);
				break;
			case 201 :
				c= new Color(255, 251, 0);
				break;
			case 202 :
				c= new Color(255, 253, 0);
				break;
			case 203 :
				c= new Color(255, 255, 0);
				break;
			case 204 :
				c= new Color(255, 255, 0);
				break;
			case 205 :
				c= new Color(255, 255, 5);
				break;
			case 206 :
				c= new Color(255, 255, 10);
				break;
			case 207 :
				c= new Color(255, 255, 15);
				break;
			case 208 :
				c= new Color(255, 255, 20);
				break;
			case 209 :
				c= new Color(255, 255, 25);
				break;
			case 210 :
				c= new Color(255, 255, 30);
				break;
			case 211 :
				c= new Color(255, 255, 35);
				break;
			case 212 :
				c= new Color(255, 255, 40);
				break;
			case 213 :
				c= new Color(255, 255, 45);
				break;
			case 214 :
				c= new Color(255, 255, 50);
				break;
			case 215 :
				c= new Color(255, 255, 55);
				break;
			case 216 :
				c= new Color(255, 255, 60);
				break;
			case 217 :
				c= new Color(255, 255, 65);
				break;
			case 218 :
				c= new Color(255, 255, 70);
				break;
			case 219 :
				c= new Color(255, 255, 75);
				break;
			case 220 :
				c= new Color(255, 255, 80);
				break;
			case 221 :
				c= new Color(255, 255, 85);
				break;
			case 222 :
				c= new Color(255, 255, 90);
				break;
			case 223 :
				c= new Color(255, 255, 95);
				break;
			case 224 :
				c= new Color(255, 255, 100);
				break;
			case 225 :
				c= new Color(255, 255, 105);
				break;
			case 226 :
				c= new Color(255, 255, 110);
				break;
			case 227 :
				c= new Color(255, 255, 115);
				break;
			case 228 :
				c= new Color(255, 255, 120);
				break;
			case 229 :
				c= new Color(255, 255, 125);
				break;
			case 230 :
				c= new Color(255, 255, 130);
				break;
			case 231 :
				c= new Color(255, 255, 135);
				break;
			case 232 :
				c= new Color(255, 255, 140);
				break;
			case 233 :
				c= new Color(255, 255, 145);
				break;
			case 234 :
				c= new Color(255, 255, 150);
				break;
			case 235 :
				c= new Color(255, 255, 155);
				break;
			case 236 :
				c= new Color(255, 255, 160);
				break;
			case 237 :
				c= new Color(255, 255, 165);
				break;
			case 238 :
				c= new Color(255, 255, 170);
				break;
			case 239 :
				c= new Color(255, 255, 175);
				break;
			case 240 :
				c= new Color(255, 255, 180);
				break;
			case 241 :
				c= new Color(255, 255, 185);
				break;
			case 242 :
				c= new Color(255, 255, 190);
				break;
			case 243 :
				c= new Color(255, 255, 195);
				break;
			case 244 :
				c= new Color(255, 255, 200);
				break;
			case 245 :
				c= new Color(255, 255, 205);
				break;
			case 246 :
				c= new Color(255, 255, 210);
				break;
			case 247 :
				c= new Color(255, 255, 215);
				break;
			case 248 :
				c= new Color(255, 255, 220);
				break;
			case 249 :
				c= new Color(255, 255, 225);
				break;
			case 250 :
				c= new Color(255, 255, 230);
				break;
			case 251 :
				c= new Color(255, 255, 235);
				break;
			case 252 :
				c= new Color(255, 255, 240);
				break;
			case 253 :
				c= new Color(255, 255, 245);
				break;
			case 254 :
				c= new Color(255, 255, 250);
				break;
			case 255 :
				c= new Color(255, 255, 255);
				break;
			default :
				c= new Color(0, 0, 0);
		} // switch
		return c;
	} // getColor()

	public static int getRGB(int index)
	{
		Color c = getColor(index);
		
		return c.getRGB();
	}
	
	/** Returns ping pong color. */
	public static Color getColorPlus(int index)
	{
		int i2 = index % (256 + 255);
		
		if (i2 < 256)
			return getColor(i2);
		
		return getColor(256 + 255 - i2);	
	}
	
} // RainbowPalette
